doorsos::ST_busy		equ	_ROM_CALL_0E2
doorsos::ST_eraseHelp	equ	_ROM_CALL_0E3
doorsos::ST_showHelp		equ	_ROM_CALL_0E6

doorsos::HeapAlloc		equ	_ROM_CALL_090
doorsos::HeapAllocThrow 	equ 	_ROM_CALL_093
doorsos::HeapFree		equ	_ROM_CALL_097
doorsos::HeapFreeIndir	equ	_ROM_CALL_098
doorsos::HeapRealloc 	equ	_ROM_CALL_09D

doorsos::ERD_dialog	equ	_ROM_CALL_151
doorsos::ER_catch	equ	_ROM_CALL_154
doorsos::ER_throwVar	equ	_ROM_CALL_153
doorsos::ER_success 	equ	_ROM_CALL_155

doorsos::reset_link	equ	_ROM_CALL_24C
doorsos::flush_link	equ	_ROM_CALL_24D
doorsos::receive	equ	_ROM_CALL_24F
doorsos::transmit	equ	_ROM_CALL_250
doorsos::tx_free	equ	_ROM_CALL_252

doorsos::sprintf	equ	_ROM_CALL_053
doorsos::DrawStrXY	equ	_ROM_CALL_1A9
doorsos::FontSetSys	equ	_ROM_CALL_18F
doorsos::FontGetSys	equ	_ROM_CALL_18E

doorsos::DrawTo	equ	_ROM_CALL_19C
doorsos::MoveTo	equ	_ROM_CALL_19D
doorsos::PortSet	equ	_ROM_CALL_1A2
doorsos::PortRestore	equ	_ROM_CALL_1A3

doorsos::WinActivate	equ	_ROM_CALL_001
doorsos::WinClose	equ	_ROM_CALL_00B
doorsos::WinOpen equ _ROM_CALL_01E
doorsos::WinStrXY equ _ROM_CALL_026
doorsos::strcmp equ _ROM_CALL_271
doorsos::strlen equ _ROM_CALL_27E
doorsos::strncmp equ _ROM_CALL_272
doorsos::strncpy equ _ROM_CALL_26D
doorsos::strcat equ _ROM_CALL_26E
doorsos::strchr equ _ROM_CALL_274
doorsos::memset equ _ROM_CALL_27C
doorsos::memcmp equ _ROM_CALL_270
doorsos::memcpy equ _ROM_CALL_26A
doorsos::memmove equ _ROM_CALL_26B
doorsos::_du32u32 equ _ROM_CALL_2AA
doorsos::_ds32s32 equ _ROM_CALL_2A8
doorsos::_du16u16 equ _ROM_CALL_2A6
doorsos::_ds16u16 equ _ROM_CALL_2A4
doorsos::_ru32u32 equ _ROM_CALL_2AB
doorsos::_rs32s32 equ _ROM_CALL_2A9
doorsos::_ru16u16 equ _ROM_CALL_2A7
doorsos::_rs16u16 equ _ROM_CALL_2A5
doorsos::DerefSym equ _ROM_CALL_079
doorsos::MenuPopup equ _ROM_CALL_03B
doorsos::MenuBegin equ _ROM_CALL_036
doorsos::MenuOn equ _ROM_CALL_03A

doorsos::ArchiveErase equ _ROM_CALL_16A+$10
doorsos::ArchiveWrite equ _ROM_CALL_171



CALCULATOR		equ	_RAM_CALL_000
LCD_WIDTH		equ	_RAM_CALL_001
LCD_HEIGHT		equ	_RAM_CALL_002
doorsos::ROM_base	equ	_RAM_CALL_003
LCD_LINE_BYTES	equ	_RAM_CALL_004
KEY_LEFT		equ	_RAM_CALL_005
KEY_RIGHT		equ	_RAM_CALL_006
KEY_UP			equ	_RAM_CALL_007
KEY_DOWN		equ	_RAM_CALL_008
KEY_UPRIGHT		equ	_RAM_CALL_009
KEY_DOWNLEFT		equ	_RAM_CALL_00A
KEY_DIAMOND		equ	_RAM_CALL_00B
LCD_SIZE		equ	_RAM_CALL_00C
KEY_SHIFT		equ	_RAM_CALL_00D
doorsos::font_medium	equ	_RAM_CALL_00E


doorsos::font_small	equ	doorsos::font_medium+$800
doorsos::font_large	equ	doorsos::font_medium+$E00



LCD_MEM equ $4c00
doorsos::main_lcd equ LCD_MEM
doorsos::globals equ $4c00

doorsos::HomeEntryHandle equ	_ROM_CALL_109+$C
doorsos::ReturnValue	equ	_ROM_CALL_109+$12

doorsos::MaxHandles	equ	_ROM_CALL_02F+$104
doorsos::Heap      	equ     doorsos::MaxHandles+$16
doorsos::TopHeap   	equ     doorsos::MaxHandles+$A
doorsos::FirstFreeByte	equ	doorsos::MaxHandles+$2

doorsos::kb_globals	equ	_ROM_CALL_2A3+$15a
doorsos::kb_vars	equ 	doorsos::kb_globals
doorsos::ST_flags	equ	_ROM_CALL_000-$1F6
KEY_PRESSED_FLAG	equ	doorsos::kb_globals+$1c
GETKEY_CODE		equ	doorsos::MaxHandles+$1e


APD_INIT	equ	LCD_MEM+$F10
APD_TIMER	equ	LCD_MEM+$F14
APD_FLAG	equ	LCD_MEM+$F42


doorsos::FolderListHandle equ	_ROM_CALL_000-$18C
doorsos::MainHandle	equ	_ROM_CALL_000-$18A
doorsos::DefTempHandle	equ	_ROM_CALL_000-$188



doorsos::SYM_ENTRY.name equ 0
doorsos::SYM_ENTRY.flags equ 8
doorsos::SYM_ENTRY.hVal equ $c
doorsos::NULL equ 0
doorsos::H_NULL equ 0
doorsos::RAND_MAX equ $7fff
ACTIVITY_IDLE equ 0
ACTIVITY_BUSY equ 1
ACTIVITY_PAUSED equ 2
doorsos::ER_STOP equ 2
doorsos::ER_DIMENSION equ 230
doorsos::ER_MEMORY equ 670
doorsos::ER_MEMORY_DML equ 810
doorsos::UNDEFINED_TAG equ $2a
doorsos::LIST_TAG equ $d9
doorsos::MATRIX_TAG equ $db
doorsos::END_TAG equ $e5
CALC_TI89 equ 0
CALC_TI92PLUS equ 1


ROM_CALL macro
 move.l ($C8),a4
 add.l #\1*4,a4
 move.l (a4),a4
 jsr (a4)

 endm

EXTRA_RAM_TABLE macro
_extraram:
    xdef _extraram
    endm

EXTRA_RAM_ADDR macro
    dc.w \3
    dc.w \4
\2 equ _extraramaddr@\1
    endm


doorsos::DEREF     macro   ; Dn,An
	lsl.w	#2,\1
        move.l  doorsos::Heap,\2
	move.l	0(\2,\1.w),\2
		endm

SetFont	macro
	move.w	\1,-(a7)
	jsr	doorsos::FontSetSys
	addq.l	#2,a7
		endm

WriteStr	macro	;x,y,col,str
	move.w	\3,-(a7)
	pea	\4(pc)
	move.w	\2,-(a7)
	move.w	\1,-(a7)
	jsr	doorsos::DrawStrXY
	lea	10(a7),a7
                endm

WriteStrA	macro	;x,y,col,An
	move.w	\3,-(a7)
	move.l	\4,-(a7)
	move.w	\2,-(a7)
	move.w	\1,-(a7)
	jsr	doorsos::DrawStrXY
	lea	10(a7),a7
                endm

GetKeyStat	MACRO
		move.w		#$FFFE,d0
		move.b		\1,d1
		rol.w 		d1,d0
		move.w		d0,($600018)
		nop
		nop
		nop
		nop
		move.b		($60001B),d0
		ENDM

DEREF macro
 doorsos::DEREF \1,\2
 endm

handle_ptr macro
 DEREF \1,\2
 endm

doorsos::DEREF_SYM macro
 move.l \1,-(sp)
 jsr doorsos::DerefSym
 add.l #4,sp
 endm


doorsos::ER_throw macro
 dc.w $A000+\1
 endm

romfunc::ST_eraseHelp equ $e3
romfunc::ST_showHelp equ $e6
romfunc::HeapFree equ $97
romfunc::HeapAlloc equ $90
romfunc::ER_catch equ $154
romfunc::ER_success equ $155
romfunc::reset_link equ $24c
romfunc::flush_link equ $24d
romfunc::tx_free equ $252
romfunc::transmit equ $250
romfunc::receive equ $24f
romfunc::HeapFreeIndir equ $98
romfunc::ST_busy equ $e2
romfunc::ER_throwVar equ $153
romfunc::HeapRealloc equ $9d
romfunc::sprintf equ $53
romfunc::DrawStrXY equ $1a9
romfunc::FontSetSys equ $18f
romfunc::DrawTo equ $19c
romfunc::MoveTo equ $19d
romfunc::PortSet equ $1a2
romfunc::PortRestore equ $1a3
romfunc::WinActivate equ $1
romfunc::WinClose equ $b
romfunc::WinOpen equ $1e
romfunc::WinStrXY equ $26
romfunc::HeapAllocThrow equ $93
romfunc::strcmp equ $271
romfunc::FontGetSys equ $18e
romfunc::strlen equ $27e
romfunc::strncmp equ $272
romfunc::strncpy equ $26d
romfunc::strcat equ $26e
romfunc::strchr equ $274
romfunc::memset equ $27c
romfunc::memcmp equ $270
romfunc::memcpy equ $26a
romfunc::memmove equ $26b
romfunc::_du32u32 equ $2aa
romfunc::_ds32s32 equ $2a8
romfunc::_du16u16 equ $2a6
romfunc::_ds16u16 equ $2a4
romfunc::_ru32u32 equ $2ab
romfunc::_rs32s32 equ $2a9
romfunc::_ru16u16 equ $2a7
romfunc::_rs16u16 equ $2a5
romfunc::DerefSym equ $79
romfunc::MenuPopup equ $3b
romfunc::MenuBegin equ $36
romfunc::MenuOn equ $3a
romfunc::ERD_dialog equ $151
romfunc::ArchiveWrite equ $171

_library
_ti89
_ti92plus
